package com.redhat.gss;

import javax.annotation.PostConstruct;
import javax.ejb.Singleton;
import javax.ejb.Startup;

import org.kie.api.KieServices;
import org.kie.api.builder.KieScanner;
import org.kie.api.builder.ReleaseId;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

@Singleton
@Startup
public class KieSessionFactory {

    // The information about the project that contains the rules I want to fire
    // which I created using BRMS
    private final String GROUP_ID = "org.kie.example";
    private final String ARTIFACT_ID = "project1";
    private final String VERSION = "LATEST";

    private KieContainer kieContainer;

    @PostConstruct
    public void initialize() {
        System.out.println("-- INITIALIZING THE KIECONTAINER REPO --");
        KieServices kieServices = KieServices.Factory.get();
        ReleaseId id = kieServices.newReleaseId(GROUP_ID, ARTIFACT_ID, VERSION);
        kieContainer = kieServices.newKieContainer(id);
        KieScanner kScanner = kieServices.newKieScanner(kieContainer);
        kScanner.start(10000);
        System.out.println("-- KIECONTAINER INITIALIZED AND SCANNING --");
    }

    public KieSession getSession() {
        return kieContainer.newKieSession();
    }

}
